diff --git a/ChangeLog b/ChangeLog
index fe7e286f85..c7b8945258 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -2,6 +2,8 @@
   * Fix error reading multi-layer XCF image file.
   * Fix possible stack overflow in WEBP reader (reference
     https://github.com/ImageMagick/ImageMagick/issues/907)
+  * Fixed numerous memory leaks (reference
+    https://github.com/ImageMagick/ImageMagick/issues).
 
 2017-12-16  7.0.7-15 Cristy  <quetzlzacatenango@image...>
   * Release ImageMagick version 7.0.7-15, GIT revision 21924:30cb31746:20171216.
diff --git a/coders/png.c b/coders/png.c
index e36b3cadf8..7dd818b500 100644
--- a/coders/png.c
+++ b/coders/png.c
@@ -2383,7 +2383,9 @@ static Image *ReadOnePNGImage(MngInfo *mng_info,
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
           "  exit ReadOnePNGImage() with error.");
 
-      return(GetFirstImageInList(image));
+      if (image != (Image *) NULL)
+        image=DestroyImage(image);
+      return(image);
     }
 
   /* {  For navigation to end of SETJMP-protected block.  Within this
